package com.wm.wimobile.openappcomercios;

import androidx.databinding.ObservableBoolean;
import androidx.lifecycle.MutableLiveData;
import androidx.lifecycle.ViewModel;

import com.wm.wimobile.openappcomercios.entities.JsonInput;

import java.util.List;

public class InputViewModel extends ViewModel{
    MutableLiveData mutableJsonInput;
    JsonInput jsonInput;
    public final ObservableBoolean claveVisible = new ObservableBoolean();
    public final ObservableBoolean numReciboVisible = new ObservableBoolean();
    public final ObservableBoolean linearCompraVisible = new ObservableBoolean();
    SendDataSource.getDate sendDataRepository;
    private List<Integer> valuesTipoTransaccion;
    private int position;

    public MutableLiveData getMutableNewCLient() {
        if(mutableJsonInput == null) {
            mutableJsonInput = new MutableLiveData<>();
            jsonInput = new JsonInput();
        }
        return mutableJsonInput;
    }

    public void sendData() {
        sendDataRepository.enviarDatos();
    }

    public JsonInput getJsonInput() {
        return jsonInput;
    }

    public void setNewClient(JsonInput newClient) {
        mutableJsonInput.setValue(newClient);
    }

    public void init(SendDataSource.getDate sendDataRepository) {
        this.sendDataRepository = sendDataRepository;
        if (this.mutableJsonInput != null) {
            // ViewModel is created per Fragment so
            // we know the userId won't change
            return;
        }
        getMutableNewCLient();
        sendDataRepository.cargarDatos();
    }

    public void UpdateUi(JsonInput jsonInput){
        if (this.mutableJsonInput == null) {
            getMutableNewCLient();
        }
        mutableJsonInput.postValue(jsonInput);
    }

    public void UpdatePost(JsonInput jsonInput){
        if (this.mutableJsonInput == null) {
            getMutableNewCLient();
        }
        mutableJsonInput.postValue(jsonInput);
    }


    public List<Integer> getValuesTipoTransaccion() {
        return valuesTipoTransaccion;
    }

    public void setValuesTipoTransaccion(List<Integer> valuesTipoTransaccion) {
        this.valuesTipoTransaccion = valuesTipoTransaccion;
    }

    public int getPosition() {
        return position;
    }

    public void setPosition(int position) {
        this.position = position;
        //if (position != 0)
        jsonInput.setTipoTransaccion(valuesTipoTransaccion.get(position));

        switch (position){
            case 0:
                hideClaveSuperv();
                showLinearCompra();
                hideNumRecibo();
                break;
            case 1:
                showClaveSuperv();
                showNumRecibo();
                hideLinearCompra();
                break;
            case 2:
                showClaveSuperv();
                showNumRecibo();
                hideLinearCompra();
                break;
            case 3:
                showClaveSuperv();
                hideLinearCompra();
                hideNumRecibo();
                break;
            case 4:
                showClaveSuperv();
                hideLinearCompra();
                hideNumRecibo();
                break;
            case 5:
                hideClaveSuperv();
                showLinearCompra();
                hideNumRecibo();
                break;
            case 6:
                showClaveSuperv();
                hideLinearCompra();
                hideNumRecibo();
                break;
            case 7:
                showClaveSuperv();
                hideLinearCompra();
                hideNumRecibo();
                break;
            case 8:
                showClaveSuperv();
                hideLinearCompra();
                hideNumRecibo();
                break;
            default:
                showClaveSuperv();
                showLinearCompra();
                showNumRecibo();
                break;
        }

    }

    public void showClaveSuperv() {
        if (!claveVisible.get()) {
            claveVisible.set(true);
        }
    }

    public void hideClaveSuperv() {
        if (claveVisible.get()) {
            claveVisible.set(false);
        }
    }


    public void showLinearCompra() {
        if (!linearCompraVisible.get()) {
            linearCompraVisible.set(true);
        }
    }

    public void hideLinearCompra() {
        if (linearCompraVisible.get()) {
            linearCompraVisible.set(false);
        }
    }


    public void showNumRecibo() {
        if (!numReciboVisible.get()) {
            numReciboVisible.set(true);
        }
    }

    public void hideNumRecibo() {
        if (numReciboVisible.get()) {
            numReciboVisible.set(false);
        }
    }
}
