package com.wm.wimobile.openappcomercios;

import androidx.annotation.Nullable;
import androidx.appcompat.app.AppCompatActivity;
import androidx.databinding.DataBindingUtil;
import androidx.lifecycle.Observer;
import androidx.lifecycle.ViewModelProviders;

import android.content.ActivityNotFoundException;
import android.content.ComponentName;
import android.content.Intent;
import android.os.Bundle;
import android.widget.Toast;

import com.wm.wimobile.openappcomercios.databinding.ActivityMainBinding;
import com.wm.wimobile.openappcomercios.entities.JsonInput;

public class MainActivity extends AppCompatActivity implements SendDataSource.getDate.cargarDatosCallBack {

    private SendDataSource.getDate sendDataSource;
    private InputViewModel inputViewModel;
    private ActivityMainBinding activityMainBinding;
    Intent i;
    public static String PACKAGE = "rbm.pax.wimobile.com.rbmappcomercioswm";
    public static String SEND_COMERCIOS = "rbm.pax.wimobile.com.rbmappcomercios.features.mainmenu.ui.MainMenuActivity";
    public static String packageName = "package";
    public static String data_input = "data_input";
    private static Integer REQUESTCOMERCIOS= 100;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        activityMainBinding = DataBindingUtil.setContentView(this, R.layout.activity_main);
        inputViewModel = ViewModelProviders.of(this).get(InputViewModel.class);
        sendDataSource = new SendDataRepository(getApplicationContext(),this,inputViewModel);
        inputViewModel.init(sendDataSource);
        inputViewModel.getMutableNewCLient().observe(this, new Observer<JsonInput>() {
            @Override
            public void onChanged(JsonInput newClient) {

            }
        });
        this.getLifecycle();
        activityMainBinding.setInputViewModel(inputViewModel);
        activityMainBinding.setLifecycleOwner(this);
    }

    @Override
    public void onSuccess(String json) {
        ComponentName cn = new ComponentName(PACKAGE,
                SEND_COMERCIOS);
        activityMainBinding.input.setText(json);
        i = new Intent(Intent.ACTION_SEND);
        i.setComponent(cn);
        i.putExtra(data_input, json);
        i.putExtra(packageName, getApplicationContext().getPackageName());
        try {
            startActivityForResult(i, REQUESTCOMERCIOS);
        } catch (ActivityNotFoundException e) {
            Toast.makeText(getApplicationContext(),getApplicationContext().getString(R.string.not_found_app_bio)
                    ,  Toast.LENGTH_SHORT).show();
        }
    }

    @Override
    public void error() {

    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, @Nullable Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        if(requestCode == REQUESTCOMERCIOS){
            String output = data.getStringExtra("data_output");
            activityMainBinding.output.setText(output);
        }
    }
}
